
# coding: utf-8

# #CSE 546 Fall 2014 Python Review
# Tianqi Chen

# ##Outline
# * Basic data types
# * list and map
# * function, passing by reference, return value
# * numpy matrix  (see numpy notebook)
#   - 0 indexing
#   - matrix vs ndarray
#   - basic slicing
#   - advanced slicing
# * scipy.sparse.csc_matrix
# * Example
#   - Linear regression (see mushroom notebook)
# 

# # Basic Data Types
# * int, float, string

# In[2]:

# here are some basic types you can use in python
a = 1
b = 1.1
c = 'machine learning is awesome thing to learn about'
# this is a list
mylist = [1, 2, 5, 4]
# this is a dict(map)
mymap = {'hello':1, 'world':2}


# In[3]:

# this cell is only used for typing


# In[4]:

a + b


# In[5]:

'CSE%d %s awesome' % (546, 'is')
c.split()


# In[6]:

# this is how you split a string
print c.split()
print c.split('is')
# this is string formation
print 'CSE%d %s awsome' % (546, 'is')


# # Lists and Tuples

# In[7]:

mylist = [1,2,5,4]
# python is 0 based indexing!
print mylist[0]
print mylist[1:]
print mylist[0:2]
print mylist[0:-2]
print mylist[:-2]


# In[8]:

# this cell is only used for typing
mylist= [1,2,3,4]
mylist.append(5)
mylist


# In[9]:

print mylist
mylist.append(10)
print mylist


# In[10]:

mytuple = (1,2,3,4)
mytuple[1:3]
a=1;b=2
a,b = b,a
a
b


# In[11]:

# list comprehension, very useful to write short and elegant code
print mylist
print [x+10 for x in mylist if x != 2]


# ## Dict (map)

# In[12]:

mymap = {'hello':1, 'world':2}
mymap


# In[13]:

print mymap['hello']
mymap[10] = 1
mymap


# In[14]:

mymap[10] = 'great'
mymap


# # Control Flows

# In[15]:

for i in range(4):
    print i
print '--------------'
for i in range(1,4):
    print i
print '--------------'
for x in mylist:
    print x
print '--------------'
for k, v in mymap.items():
    print '%s->%s' % (str(k), str(v))
for i in range(4):
    if i < 2:
        print i


# In[16]:

# this cell is only used for typing
print mymap.items()
for k, v in mymap.items():
    print '%s->%s' % (str(k), str(v))


# # Functions

# In[17]:

def add(a,b):
    return a + b
add(10,2)


# In[18]:

# define functions using lambda
add2 = lambda x,y: x+y
add2(3,4)


# In[19]:

# complex data structures(all types except for string, 
#numbers) are passed by reference!!
def myfunc(a):
    a.append(10)

a = [1,2,3]
b = myfunc(a)
print a


# In[20]:

def myfunc(a):
    a += 'world'

a = 'hello'
myfunc(a)
a


# In[21]:

sorted([3,1,-5], key = lambda x:abs(x))


# ## File Operations

# In[22]:

fi = open('data/featmap.txt')
print fi.readline()

fo = open('test.txt', 'w')
fo.write('hello\nworld')
fo.close()


# ## Count Words in a Reviews

# In[23]:

def countword(fname):
    wcnt = {}
    for l in open(fname):
        arr = l.split()
        for wd in arr:
            if wd in wcnt:
                wcnt[wd] += 1
            else:
                wcnt[wd] = 1
    return wcnt
def topword(fname, topk=10):
    wcnt = countword(fname)
    sortedlist = sorted(wcnt.items(), key = lambda x: -x[1])
    return sortedlist[:topk]
def calcratio(fpos, fneg, topk=10):
    wpos = countword(fpos)
    wneg = countword(fneg)
    wratio = {}
    for k in wpos.keys():
        if k in wneg:
            wratio[k] = float(wpos[k]+10) / (wneg[k]+10)
    sortedlist = sorted(wratio.items(), key = lambda x: -x[1])
    return sortedlist[:topk]  

#topword('rt-polaritydata/rt-polarity.pos')
calcratio('rt-polaritydata/rt-polarity.pos','rt-polaritydata/rt-polarity.neg')

